/*
 * $Header: /home/gene/src/lisp-script/src/RCS/demo0003.c,v 1.2 2004/03/25 09:57:15 gene Exp $
 */

/*
 * Copyright (c) 2004.  Gene Michael Stover.  All rights reserved.
 *
 * This file is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/*
 * Prints the value returned by IO_TmpPathname.
 * Does this 20 times.
 */

#include "this.h"

static int
S_Init ()
{
  int rc = 0;
  
  srand (time (NULL) + getpid ());
  return rc;
}

static int
S_Run ()
{
  int rc = 0, i;
  char *pathname;

  for (i = 0; i < 20; ++i) {
    pathname = IO_TmpPathname ();
    printf ("\n%s", pathname);
    xfree (pathname);
  }
  printf ("\n");
  return rc;
}

static void
S_Uninit ()
{
}

int
main ()
{
  int rc = 0;

  if (S_Init () == 0) {
    if (S_Run () == 0) {
      /* good */
    } else {
      fprintf (stderr, "\n%s:%d: S_Run failed", __FILE__, __LINE__);
      rc = 22;
    }
    S_Uninit ();
  } else {
    fprintf (stderr, "\n%s:%d: S_Init failed", __FILE__, __LINE__);
    rc = 3;
  }
  return rc == 0 ? EXIT_SUCCESS : EXIT_FAILURE;
}

/* --- end of file --- */
