/*
 * $Header: /home/gene/src/lisp-script/src/RCS/io.h,v 1.3 2004/03/25 09:57:15 gene Exp $
 */

/*
 * Copyright (c) 2004.  Gene Michael Stover.  All rights reserved.
 *
 * This file is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/*
 * Copies the source to the destination.  Assumes they are text
 * files.  Copies a line at a time.  Return 0 on success, non-zero
 * on error.
 */
int IO_CopyStreams (/* FILE *dst, FILE *src */);

/*
 * Reads from the stream until it reads end-of-line or end-of-file.
 * Then returns.
 */
void IO_DiscardLine (/* FILE *fp */);

/*
 * Returns a reasonable directory where the user wants temporary
 * files to be located.  Uses the TMPDIR environment variable if
 * it is defined.  Otherwise, uses "/tmp" if it's a directory &
 * the user can write to it.  Otherwise, uses "./".
 */
char *IO_GetTmpDir ();

/*
 * Returns true if & only if the pathname refers to a directory.
 */
Boolean IO_IsDirectory (/* char pathname[] */);

/*
 * Create a new file that did not exist before, & return the
 * pathname to it.  The pathname is dynamically allocated.
 * Caller must dispose of it with 'xfree'.
 */
char *IO_MakeUniqueFile ();

/*
 * Return the absolute pathname of a temporary file.  Doesn't
 * create the file.  Doesn't verify that a a file with that name
 * doesn't already exist.  Just makes a pathname & returns it.
 * The pathname is allocated with 'xmalloc', so the caller must
 * release it with 'xfree'.
 */
char *IO_TmpPathname ();

/* --- end of file --- */
