/*
 * $Header: /home/gene/src/lisp-script/src/RCS/sbcl.c,v 1.3 2004/04/06 07:45:19 gene Exp $
 */
/*
 * Copyright (c) 2004.  Gene Michael Stover.  All rights reserved.
 *
 * This file is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "this.h"

char *
LISP_MakeCommand (lisp_pathname, script_pathname)
     char lisp_pathname[];
     char script_pathname[];
{
  char *x;
  int sz;
  static char fmt[] = "%s --noinform --end-runtime-options --noprint"
    " --disable-debugger --load \"%s\" --end-toplevel-options";

  sz = strlen (lisp_pathname) + strlen (script_pathname) + strlen (fmt) + 1;
  x = (char *) xmalloc (sz);
  sprintf (x, fmt, lisp_pathname, script_pathname);
  assert (strlen (x) < sz);
  return x;
}

void
LISP_WriteBeginning (fp)
     FILE *fp;
{
  /* Don't need to write anything special for SBCL, though we could write
   * some declarations to reduce the number of superfluous optimization
   * warnings it prints. */
}

void
LISP_WriteEnding (fp)
     FILE *fp;
{
  /* SBCL does not automatically exit upon encountering end-of-input,
   * so to be sure it exits, we'll insert a QUIT.  The Lisp program
   * should ensure that it exits; it should not rely on this QUIT.  We're
   * inserting this QUIT just in case. */
  fprintf (fp, "\n(quit)\n");
}

/* --- end of file --- */

