;;;
;;; $Header: /home/gene/src/lisp-script/src/RCS/script.lisp,v 1.3 2004/04/20 06:36:43 gene Exp $
;;;

;;; To use this module, LOAD it.  Call SCRIPT-START before your
;;; script does anything else important.  Call SCRIPT-EXIT
;;; before your script ends.

;; For SBCL, disable the warnings about how some function calls must be
;; evaluated at run-time & other trivialities of inefficiency.
;; I should wrap this in a construct that will evaluate it only if
;; the Lisp is SBCL, but I can't remember the notation.
; (declaim (optimize (sb-ext:inhibit-warnings 3)))

(defun script-start ()
  'script-start)

;; Some Lisps quit at end of input.  Others, with EXIT.  Still others,
;; with QUIT.  We'll try all of them until one works.  God help us if
;; none of them work.  We might have a lock-up.
(defun script-exit (&optional (status 0))
  (declare (type integer status))
  ;; This convoluted MAPC over a couple of hard-coded functions is here so
  ;; SBCL won't give it's shitty compile-time warnings about how EXIT is not
  ;; a defined function.
  (mapc #'(lambda (sym)
	    (declare (type symbol sym))
	    (when (fboundp sym)
	      ;; Try to exit in ways that would tell unix that tell the shell
	      ;; that we had success.
	      (ignore-errors (funcall sym status))
	      ;; Try it in another way.
	      (ignore-errors (funcall sym :unix-status status))
	      ;; If we get here, the previous funcall didn't work, so
	      ;; try to exit in those same ways but without the success code.
	      (ignore-errors (funcall sym))))
	'(exit quit))
  ;; Nothing worked, so we'll return.  I sure hope this Lisp exits when
  ;; it finds the end-of-file in the script.
  'script-exit)

;;; --- end of file ---
