/*
 * $Header: /home/gene/src/lisp-script/src/RCS/test0003.c,v 1.1 2004/04/06 07:30:45 gene Exp $
 */
/*
 * Copyright (c) 2004.  Gene Michael Stover.  All rights reserved.
 *
 * This file is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/*
 * Tests function LISP_MakeCommand from the file "uxlisp.c".
 * Uses a make-believe hard-coded pathname for the uxlisp interpreter.
 *
 * This program must be linked with "sbcl.c".  I mean, must be linked with
 * the *.o file that results from compling sbcl.c.
 */

#include "this.h"

static char lisp_pathname[] = "/usr/pkg/uxlisp/bin/uxlisp";
static char script_pathname[] = "foofoo";
static char expect[] =
  "cd /usr/pkg/uxlisp/bin; /usr/pkg/uxlisp/bin/uxlisp foofoo";

int
main ()
{
  int rc = 0;
  char *x;

  x = LISP_MakeCommand (lisp_pathname, script_pathname);
  if (x != NULL) {
    if (strcmp (x, expect) == 0) {
      /* good */
    } else {
      fprintf (stderr, "%s:%d:", __FILE__, __LINE__);
      fprintf (stderr, " LISP_MakeCommand returned \"%s\".", x);
      fprintf (stderr, "  Expected \"%s\".", expect);
      fprintf (stderr, "\n");
      rc = -17;
    }
    xfree (x);
  } else {
    fprintf (stderr, "%s:%d:", __FILE__, __LINE__);
    fprintf (stderr, " LISP_MakeCommand returned NULL.");
    fprintf (stderr, "\n");
    rc = 3;
  }
  return rc == 0 ? EXIT_SUCCESS : EXIT_FAILURE;
}

/* --- end of file --- */
