/*
 * $Header: /home/gene/src/lisp-script/src/RCS/uxlisp.c,v 1.3 2004/04/08 14:16:17 gene Exp $
 */
/*
 * Copyright (c) 2004.  Gene Michael Stover.  All rights reserved.
 *
 * This file is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "this.h"

/*
 * Return the directory part of pathname.  Yes, many unices have their
 * own 'dirname' function, but I have found them to be non-portable.
 * Some of them retain a trailing /, while others remove it.
 * The directory part is a dynamically allocated string.  Caller must
 * release the memory with 'xfree'.
 */
static char *
S_Dirname (pathname)
     char pathname[];
{
  char *x;

  x = STR_Strdup (pathname);
  /* Locate the final / character.  Replace it with
   * a '\0' terminator.   This line of code assumes there IS a '/'
   * character in the pathname. */
  assert (strrchr (x, '/') != NULL);
  *(strrchr (x, '/')) = '\0';
  return x;
}

char *
LISP_MakeCommand (lisp_pathname, script_pathname)
     char lisp_pathname[];
     char script_pathname[];
{
  char *x, *dirname;
  int sz;
  static char fmt[] = "OPENLISP=\"%s\" %s -quiet %s";

  dirname = S_Dirname (lisp_pathname);
  sz = strlen (dirname) + strlen (lisp_pathname) + strlen (script_pathname) +
    strlen (fmt) + 1;
  x = (char *) xmalloc (sz);
  sprintf (x, fmt, dirname, lisp_pathname, script_pathname);
  assert (strlen (x) < sz);
  xfree (dirname);
  return x;
}

void
LISP_WriteBeginning (fp)
     FILE *fp;
{
  /* Don't need to write anything special for clisp. */
}

void
LISP_WriteEnding (fp)
     FILE *fp;
{
  /* Don't need to write anything special for clisp. */
}

/* --- end of file --- */

