/*
 * $Header: /home/gene/src/lisp-script/src/RCS/xmalloc.c,v 1.1 2004/03/24 07:31:47 gene Exp $
 */

/*
 * Copyright (c) 2004.  Gene Michael Stover.  All rights reserved.
 *
 * This file is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "this.h"

void *
xmalloc (sz)
     int sz;
{
  void *p;

  assert (sz > 0);
  p = malloc (sz);
  if (p == NULL) {
    fprintf (stderr, "\n%s:%d: malloc: %s", __FILE__, __LINE__,
	     strerror (errno));
    abort ();
  }
  return p;
}

void
xfree (p)
     void *p;
{
  if (p != NULL) {
    free (p);
  } else {
    fprintf (stderr, "\n%s:%d: warning: xfree NULL", __FILE__, __LINE__);
  }
}

/* --- end of file --- */
